<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl">

  <xsl:template match="/">
    <html>
      <xsl:apply-templates/>
    </html>
  </xsl:template>

  <xsl:template match="CORRECTION">
    <head>
      <title>QuizzML : Correction</title>
      <link href="QuizzML.css" rel="stylesheet" type="text/css"/>
    </head>
    <body>
      <table>
        <xsl:apply-templates/>
      </table>
    </body>
  </xsl:template>

  <xsl:template match="POLITESSE">
    <caption>
      <h1><xsl:value-of select="."/>, voici la correction de votre quizz</h1>
    </caption>
    <tr>
      <th width="5%">No.</th>
      <th width="50%">Question</th>
      <th width="20%">R&#233;ponse</th>
      <th width="20%">Solution</th>
      <th width="5%">Score</th>
    </tr>
  </xsl:template>

  <xsl:template match="QUESTION">
    <tr>
      <td class="centre"><xsl:value-of select="@numero"/></td>
      <xsl:apply-templates/>
      <td class="centre"><xsl:value-of select="@resultat"/>/<xsl:value-of select="@score"/></td>
    </tr>
  </xsl:template>

  <xsl:template match="ENONCE">
    <td><xsl:value-of select="."/></td>
  </xsl:template>

  <xsl:template match="REPONSE">
      <xsl:if test=".[@reponse='faux']">
        <td class="faux"><xsl:value-of select="."/></td>
      </xsl:if>
      <xsl:if test=".[@reponse='juste']">
        <td class="juste"><xsl:value-of select="."/></td>
      </xsl:if>
  </xsl:template>

  <xsl:template match="SOLUTION">
    <td class="centre"><xsl:value-of select="."/></td>
  </xsl:template>

  <xsl:template match="RESULTAT">
    <td class="droite" colspan="4">TOTAL</td>
    <xsl:if test=".[@appreciation='nul']">
      <td class="nul"><xsl:value-of select="./NOTE"/>/<xsl:value-of select="./TOTAL"/></td>
    </xsl:if>
    <xsl:if test=".[@appreciation='mauvais']">
      <td class="mauvais"><xsl:value-of select="./NOTE"/>/<xsl:value-of select="./TOTAL"/></td>
    </xsl:if>
    <xsl:if test=".[@appreciation='moyen']">
      <td class="moyen"><xsl:value-of select="./NOTE"/>/<xsl:value-of select="./TOTAL"/></td>
    </xsl:if>
    <xsl:if test=".[@appreciation='bon']">
      <td class="bon"><xsl:value-of select="./NOTE"/>/<xsl:value-of select="./TOTAL"/></td>
    </xsl:if>
  </xsl:template>

</xsl:stylesheet>
